/* Some standard functions for photopnmtools.  Note: we have c functions in a
 * header file here. 
 *
 * This file is part of PhotoPNMTools,
 * Release $Name:  $,
 * File rev. $Id: stdpnm.h,v 1.2 2003/02/22 12:21:19 schooten Exp $.
 *
 * Copyright (c) 2002, 2003 by B.W. van Schooten. All rights reserved.
 * This software is distributed under the Perl Artistic License.
 * No warranty. See file 'artistic.license' for more details.
 *
 * boris@13thmonkey.org
 * www.13thmonkey.org/~boris/photopnmtools/
 */

//#define MAX(a,b) ( (a) > (b) ? (a) : (b) )

#define MAX3(a,b,c) ( (a) > (b)   ? \
		( (a) > (c) ? (a) : (c) ) : \
		( (b) > (c) ? (b) : (c) )  )

#define MIN3(a,b,c) ( (a) < (b)   ? \
		( (a) < (c) ? (a) : (c) ) : \
		( (b) < (c) ? (b) : (c) )  )

struct rgb {
	float r,g,b;
};

	struct rgb
xeltorgb(xel rgbxel, int maxpix) {
	struct rgb rgb;
	rgb.r = (double)rgbxel.r / (double)maxpix;
	rgb.g = (double)rgbxel.g / (double)maxpix;
	rgb.b = (double)rgbxel.b / (double)maxpix;
	return rgb;
}

	xel
rgbtoxel(struct rgb rgb, int maxpix) {
/*** NOTE: clips values <0.0 or >1.0 */
	xel rgbxel;
	if (rgb.r > 1.0) {/*fprintf(stderr,"r:%f\n",r);*/ rgb.r = 1.0; }
	if (rgb.g > 1.0) {/*fprintf(stderr,"g:%f\n",g);*/ rgb.g = 1.0; }
	if (rgb.b > 1.0) {/*fprintf(stderr,"b:%f\n",b);*/ rgb.b = 1.0; }
	if (rgb.r < 0.0) {/*fprintf(stderr,"r:%f\n",r);*/ rgb.r = 0.0; }
	if (rgb.g < 0.0) {/*fprintf(stderr,"g:%f\n",g);*/ rgb.g = 0.0; }
	if (rgb.b < 0.0) {/*fprintf(stderr,"b:%f\n",b);*/ rgb.b = 0.0; }
	rgbxel.r = rgb.r * maxpix;
	rgbxel.g = rgb.g * maxpix;
	rgbxel.b = rgb.b * maxpix;
	return rgbxel;
}

	struct rgb **
rgballocarray(int xsize, int ysize, xel **source, int maxpix) {
/*** create two dimensional array. Copy source array if not null, otherwise
 *** fill with black. In case source==null, maxpix is don't care.
 ***/
	int y,x;
	struct rgb **buf = malloc(sizeof(struct rgb *)*ysize);
	if (!buf) { fprintf(stderr,"Cannot malloc!\n"); exit(1); }
	for (y=0; y<ysize; y++) {
		buf[y]=malloc(sizeof(struct rgb)*xsize);
		if (source) {
			for (x=0; x<xsize; x++) {
				buf[y][x] = xeltorgb(source[y][x],maxpix);
			}
		} else {
			for (x=0; x<xsize; x++) {
				buf[y][x].r = 0.0;
				buf[y][x].g = 0.0;
				buf[y][x].b = 0.0;
			}
		}
	}
	return buf;
}

	void
xelarraytorgb(int xsize,int ysize, xel **source, struct rgb **dest,int maxpix){
/*** copy xel array to rgb array
 ***/
	int x,y;
	for (y=0; y<ysize; y++) {
		for (x=0; x<xsize; x++) {
			dest[y][x] = xeltorgb(source[y][x],maxpix);
		}
	}
}

	void
rgbarraytoxel(int xsize,int ysize, struct rgb **source, xel **dest,int maxpix){
/*** copy rgb array to xel array
 ***/
	int x,y;
	for (y=0; y<ysize; y++) {
		for (x=0; x<xsize; x++) {
			dest[y][x] = rgbtoxel(source[y][x],maxpix);
		}
	}
}


